# Beeings.org map service by group Softweb inc

Deployment address: http://my-first-project-301714.ew.r.appspot.com/

Python 3.8.5

## Running the application locally

### Option 1

- Run the database emulator in a Docker container:

`$ docker run -d -p 8888:8888 storytel/gcp-datastore-emulator start --testing --host=0.0.0.0 --port=8888`

- Set the following environmental variables:

`$ export FLASK_APP=main`

`$ export FLASK_ENV=development` **OR** `$ export FLASK_ENV=testing`

`$ export DATASTORE_EMULATOR_HOST=localhost:8888`

- Run the application or test suite

`$ flask run` **OR** `$ pytest --verbose tests --cov --cov-report term --cov-report html -m "not staging"`

### Option 2

- Build the application image with `docker-compose build`

- Run the application image along with the datastore emulator with: `docker-compose up`

- At the moment this option only supports running the application in development mode

- NOTE: The application image has to be rebuilt every time a change is made

## Reporting bug and security issues

- Report bug and security issues via **New issue** -functionality

- Issue template can be found in `.gitlab/issue_templates/Bug.md`