# Weekly report: Week 1

## Tasks

### Administrative
- Discord group was created for communication
- GitLab group was created and group members + mentors added
- Template repository was forked and the name and path of the project were modified
- Six user stories with functional requirements were created as instructed.
- Group meeting with mentor was held on monday 18.1.

### Operative
- Kubernetes cluster was created to Google Cloud platform.
- GitLab Runner was installed to Kubernetes cluster using Helm
- Google App Engine was enabled and an application created
- A Google cloud service account was created to enable GitLab CI to deploy the application
- Gitlab CI was configured by setting the necessary variables and editing app.yaml and gitlab-ci.yaml files
- The pipeline was tested to be working

### Development
- Every member set up their local development environments per instructions

## Vulnerability assessment

### Injection
Not relevat at this stage of development as the application does not yet accept any input data.

### Sensitive data exposure
Authentication secrets to Google Cloud are stored as variables in the GitLab CI environment. No sensitive data should be accessible by anyone without maintainer access to the repository.

### Security misconfiguration
The Google Cloud service account was configured to have only the roles necessary to build and deploy the application. The Kubernetes cluster can only be accessed via the GitLab CI or the owner of the GCloud project.

### Using components with known vulnerabilities
Based on information from snyk.io vulnerability database no such components have been used.

### Insufficient logging & monitoring
Logging and monitoring for the Kubernetes cluster and App Engine are provided by Google Cloud platform, but no automatic alerts and log routing have been setup.
