# Weekly report: Week 3

## Tasks

### Administrative
- Four user stories with non-functional requirements were created as instructed.
- Group meeting with mentor was held on monday 1.2.
- Created time estimation report

### Operative
- Trello was set up

### DevOps
- *Work on implementing customer requirements*
    - Added social media integration to frontend
- *Setup logging and monitoring*
    - Logging uses Google Cloud Logging when the application is running inside App Engine
- *Add deployment address and badges*
    - Badges and deployment address were added to repository description
- *Add staging stage into pipeline*
    - Pipeline now has staging stage
    - Changes to *staging* branch are automatically deployed to a staging area
    - Test to verify successfull deployment was added to the pipeline
    - Staging deployment is configured to use a separate namespace in datastore to prevent polluting production data
- *Keep coverage high by adding tests*
    - New tests were added to verify input validation on backend
    - Test jobs now have access to a service container running Google Datastore Emulator. This has multiple benefits:
        - Authentication to google services is not needed
        - Testing stage always begins on a clean slate, and the test data can be reset at any point
        - Data submitted from tests is kept separate from staging and production data
- *Begin: Localization support*
    - Started planning localization
- docker-compose.yml was added to make it easier to run a local copy of the application and datastore emulator


## Vulnerability assessment

### Injection
All requests are filtered for injections and missing parameters

### Sensitive data exposure
All sensitive data is stored in environment variables

### Security misconfiguration
The Google Cloud service account was configured to have only the roles necessary to build and deploy the application. The Kubernetes cluster can only be accessed via the GitLab CI or the owner of the GCloud project. Google credentials are not used in testing environments.

### Using components with known vulnerabilities
Based on information from the snyk.io vulnerability database, no such components are in use. Only official libraries are used.

### Insufficient logging & monitoring
Logging and monitoring for the Kubernetes cluster and App Engine are provided by the Google Cloud platform. Application logs and monitoring data are streamed to Google Cloud, but automatic alerts have not been set up yet.