import unittest
import pytest
import requests
import os

# Only run tests when "staging" has been marked.
@pytest.mark.staging
class AvailabilityTest(unittest.TestCase):
    def test_availability(self):
        """Fetch web page and check "200" is returned as status code."""

        # Get the webpage, and check status code
        url = os.getenv("WEBSITE_STAGING")
        status_code = requests.get(url).status_code

        # Compare returned status code to A-OK result (200)
        self.assertEqual(
            status_code,
            200,
            f"Website {url!r} availability failed. Returned code was {status_code!r}.",
        )
